/*1:*/
#line 95 "makexdy.w"

#include <iostream> 
#include <fstream> 
#include <sstream> 
#include <string> 
#include <stdio.h> 
#include <cstring> 
#include <typeinfo> 

using namespace std;

/*:1*//*2:*/
#line 116 "makexdy.w"

class xchar;

typedef enum{enc_latin1,enc_utf8}encodingT;

/*:2*//*3:*/
#line 129 "makexdy.w"

class xifstream:public ifstream{
encodingT encoding;
friend xifstream&operator>>(xifstream&in,xchar&ch);
public:
xifstream(const string s):encoding(enc_latin1),ifstream(s.c_str()){}
};

class xofstream:public ofstream{
encodingT encoding;
friend xofstream&operator<<(xofstream&out,const xchar&ch);
friend xofstream&utf8(xofstream&s);
friend xofstream&latin1(xofstream&s);
public:
xofstream(const string s):encoding(enc_latin1),ofstream(s.c_str()){}
xofstream&operator<<(xofstream&(*f)(xofstream&)){return f(*this);}
};

/*:3*//*4:*/
#line 150 "makexdy.w"

xofstream&utf8(xofstream&s){
s.encoding= enc_utf8;
return s;
}

xofstream&latin1(xofstream&s){
s.encoding= enc_latin1;
return s;
}

/*:4*//*5:*/
#line 164 "makexdy.w"

class xchar{
wchar_t contents;
friend string xindy_armor(xchar w,const bool ascii_armor= true);
friend void write_as_utf8(ostream&out,const xchar ch);
friend void read_as_utf8(istream&in,xchar&ch);
friend xchar read_as_utf8(istream&in);
friend xofstream&operator<<(xofstream&out,const xchar&ch);
friend xifstream&operator>>(xifstream&in,xchar&ch);
operator int()const{return int(contents);}
operator char()const{return char(contents);}
public:
xchar():contents(0xffff){}
xchar(wchar_t u){contents= u;}
xchar(const xchar&ch):contents(ch.contents){}
xchar&operator= (const xchar&ch){contents= ch.contents;return*this;}
operator wchar_t()const{return contents;}
xchar&operator= (const long int value){contents= value;return*this;}
xchar&operator= (const wchar_t value){contents= value;return*this;}
};

/*:5*//*7:*/
#line 190 "makexdy.w"

inline char shift_and_mask(long int value,int shift_value= 0,
unsigned int mask= 0x3f,
unsigned int prefix= 0x80){
return char((((unsigned long)value>>shift_value)&mask)+prefix);
}

void write_as_utf8(ostream&out,const xchar ch){
if(ch.contents<=0x7f)out.put(char(ch.contents));
else if(ch.contents<=0x7ff){
out.put(shift_and_mask(ch.contents,6,0x1f,0xc0));
out.put(shift_and_mask(ch.contents));
}else if(ch.contents<=0xffff){
out.put(shift_and_mask(ch.contents,12,0x0f,0xe0));
out.put(shift_and_mask(ch.contents,6));
out.put(shift_and_mask(ch.contents));
}else if(ch.contents<=0x1fffff){
out.put(shift_and_mask(ch.contents,18,0x07,0xf0));
out.put(shift_and_mask(ch.contents,12));
out.put(shift_and_mask(ch.contents,6));
out.put(shift_and_mask(ch.contents));
}else if(ch.contents<=0x3ffffff){
out.put(shift_and_mask(ch.contents,24,0x03,0xf8));
out.put(shift_and_mask(ch.contents,18));
out.put(shift_and_mask(ch.contents,12));
out.put(shift_and_mask(ch.contents,6));
out.put(shift_and_mask(ch.contents));
}else{
out.put(shift_and_mask(ch.contents,30,0x01,0xfc));
out.put(shift_and_mask(ch.contents,24));
out.put(shift_and_mask(ch.contents,18));
out.put(shift_and_mask(ch.contents,12));
out.put(shift_and_mask(ch.contents,6));
out.put(shift_and_mask(ch.contents));
}
}

/*:7*//*8:*/
#line 230 "makexdy.w"

inline wchar_t mask_and_shift(char c,unsigned char mask,
int shift_value= 0){
return(unsigned long)((unsigned char)c&mask)<<shift_value;
}

void read_as_utf8(istream&in,xchar&ch){
char c1;
in.get(c1);
unsigned int value= (unsigned int)c1;
if(value<128)
ch.contents= value;
else if((value&0xe0)==0xc0){

char c2;
in.get(c2);
ch.contents= mask_and_shift(c1,0x1f,6)+mask_and_shift(c2,0x3f);
}else if((value&0xf0)==0xe0){

char c2,c3;
in.get(c2);in.get(c3);
ch.contents= mask_and_shift(c1,0x0f,12)+
mask_and_shift(c2,0x3f,6)+
mask_and_shift(c3,0x3f);
}else if((value&0xf8)==0xf0){

char c2,c3,c4;
in.get(c2);in.get(c3);in.get(c4);
ch.contents= mask_and_shift(c1,0x07,18)+
mask_and_shift(c2,0x3f,12)+
mask_and_shift(c3,0x3f,6)+
mask_and_shift(c4,0x3f);
}else if((value&0xfc)==0xf8){
char c2,c3,c4,c5;
in.get(c2);in.get(c3);in.get(c4);in.get(c5);
ch.contents= mask_and_shift(c1,0x03,24)+
mask_and_shift(c2,0x3f,18)+
mask_and_shift(c3,0x3f,12)+
mask_and_shift(c4,0x3f,6)+
mask_and_shift(c5,0x3f);
}else if((value&0xfe)==0xfc){
char c2,c3,c4,c5,c6;
in.get(c2);in.get(c3);in.get(c4);in.get(c5);in.get(c6);
ch.contents= mask_and_shift(c1,0x01,30)+
mask_and_shift(c2,0x07,24)+
mask_and_shift(c3,0x3f,18)+
mask_and_shift(c4,0x3f,12)+
mask_and_shift(c5,0x3f,6)+
mask_and_shift(c6,0x3f);
}else;
}

/*:8*//*9:*/
#line 285 "makexdy.w"

xofstream&operator<<(xofstream&out,const xchar&ch){
if(out.encoding==enc_utf8)
write_as_utf8(out,ch);
else{
if(ch.contents<=0xff)out.put(char(ch.contents));
else out.put('?');
}
return out;
}

ostream&operator<<(ostream&out,const xchar&ch){
write_as_utf8(out,ch);
return out;
}

xifstream&operator>>(xifstream&in,xchar&ch){
if(in.encoding==enc_utf8)
read_as_utf8(in,ch);
else{
char c1;
in.get(c1);
unsigned int value= (unsigned int)c1;
ch.contents= value;
}
return in;
}

istream&operator>>(istream&in,xchar&ch){
read_as_utf8(in,ch);
return in;
}

/*:9*//*10:*/
#line 323 "makexdy.w"

string unicode_to_triplet(wchar_t unicode){
const char digits[52]= {'A','B','C','D','E','F','G','H','I','J',
'K','L','M','N','O','P','Q','R','S','T',
'U','V','W','X','Y','Z','a','b','c','d',
'e','f','g','h','i','j','k','l','m','n',
'o','p','q','r','s','t','u','v','w','x',
'y','z'};
#if 1==0


if(unicode<0||unicode>=52*52*52)return string("???");
#endif
int d0,d1,d2;
d2= unicode/(52*52);unicode-= d2*52*52;
d1= unicode/52;unicode-= d1*52;
d0= unicode;
string result;
result= digits[d2];
result+= digits[d1];
result+= digits[d0];
return result;
}

/*:10*//*11:*/
#line 352 "makexdy.w"

string xindy_armor(xchar w,const bool ascii_armor){
unsigned int value= w.contents;
string result;
if(value<128){
result= '"';
result+= char(value);
result+= '"';
}else{
stringstream ss;
ss<<w;
if(!ascii_armor)return string("\"")+ss.str()+"\"";
string utf8(ss.str());
result= "(concatenate 'string";
for(int i= 0;i<utf8.length();i++){
stringstream ss;
ss<<" (string #\\Code"<<int((unsigned char)(utf8[i]))<<")";
string xindy_format(ss.str());
for(int j= 0;j<xindy_format.length();j++)
result+= xindy_format[j];
}
result+= ')';
}
return result;
}

/*:11*//*12:*/
#line 397 "makexdy.w"

void create_rules(istream&order){
ostringstream lettergroups,mergerules;
xchar last_lettergroup_name(L'\0');
lettergroups<<"(define-letter-group \"sssymbols\")\n";
bool beginning(true),new_prefix(false);
int index= 0;
xchar ch;
while(order>>ch){
if(wchar_t(ch)==L'\n'){
index++;
beginning= true;
new_prefix= false;
continue;
}
if(wchar_t(ch)==L' '||wchar_t(ch)==L'\t'){
index++;
new_prefix= true;
continue;
}
if(wchar_t(ch)==L'\\'){
long code;
char prefix[3];
order.get(prefix,3);
if(string(prefix)!="0x"){
cerr<<"makexdy: Invalid hex code!"<<endl;
continue;
}
order>>hex>>code;
ch= code;
}
string prefix= unicode_to_triplet(index);
if(new_prefix){
new_prefix= false;
lettergroups<<" \""<<prefix[0]<<prefix[1]<<prefix[2]<<'"';
}
if(beginning){
beginning= false;
if(wchar_t(ch)==L';'){
do order>>ch;while(order&&wchar_t(ch)!=L'\n');
beginning= true;
continue;
}
if(wchar_t(last_lettergroup_name)!=L'\0')
lettergroups<<"))\n";
lettergroups<<"(define-letter-group "<<xindy_armor(ch,false);
lettergroups<<" :after ";
if(wchar_t(last_lettergroup_name)!=L'\0')
lettergroups<<xindy_armor(last_lettergroup_name,false);
else lettergroups<<"\"sssymbols\"";
lettergroups<<" :prefixes ("
<<'"'<<prefix[0]<<prefix[1]<<prefix[2]<<'"';
last_lettergroup_name= ch;
}
mergerules<<"(merge-rule "
<<xindy_armor(ch,false)
<<" \""
<<prefix[0]<<prefix[1]<<prefix[2]
<<"\" :string)\n";
}
if(wchar_t(last_lettergroup_name)!=L'\0')lettergroups<<"))\n";
lettergroups<<"(define-letter-group \"ppparameters\" :after ";
if(wchar_t(last_lettergroup_name)!=L'\0')
lettergroups<<xindy_armor(last_lettergroup_name,false);
else lettergroups<<"\"sssymbols\"";
lettergroups<<")\n\n";
cout<<"; -*- Mode: Lisp; coding: utf-8; -*-\n\n";
cout<<lettergroups.str()<<mergerules.str();
}

/*:12*//*13:*/
#line 471 "makexdy.w"

int main(int argc,char*argv[]){
if(argc<2){
cerr<<"makexdy: no filename given"<<endl;
exit(1);
}
if(argc> 2){
cerr<<"makexdy: too many parameters"<<endl;
exit(1);
}
ifstream order(argv[1]);
if(!order.good()){
cerr<<"makexdy: file "<<argv[1]<<" not found"<<endl;
exit(1);
}
create_rules(order);
return 0;
}

/*:13*/
