/*5:*/
#line 157 "tbcrent.w"

#define entities_file_name "tbents.txt" \

#define number_of_files 37 \


#line 158 "tbcrent.w"

/*9:*/
#line 221 "tbcrent.w"

#include <cstdlib> 
#include <sstream> 
#include <iostream> 

/*:9*//*14:*/
#line 320 "tbcrent.w"

#include <string> 

/*:14*//*16:*/
#line 338 "tbcrent.w"

#include <map> 


/*:16*//*18:*/
#line 395 "tbcrent.w"

#include <fstream> 
#include <cctype> 

/*:18*//*21:*/
#line 453 "tbcrent.w"

#include <iomanip> 

/*:21*/
#line 159 "tbcrent.w"


using namespace std;

/*:5*//*6:*/
#line 166 "tbcrent.w"

const char*tblibdir_env_raw= getenv("TBLIBDIR");
const string tblibdir_env= (tblibdir_env_raw==NULL?"":tblibdir_env_raw);
#ifdef TBLIBDIR
const string file_name_prefix(tblibdir_env.size()> 0?tblibdir_env:TBLIBDIR);
#else
const string file_name_prefix(tblibdir_env.size()> 0?tblibdir_env:"");
#endif

/*:6*//*7:*/
#line 184 "tbcrent.w"

class prefixed_ifstream:public ifstream{
public:
prefixed_ifstream(string filename):ifstream(){
/*8:*/
#line 203 "tbcrent.w"

string prefixed_file_name(file_name_prefix);
if(!file_name_prefix.empty()){
if(file_name_prefix[file_name_prefix.size()-1]!='/')
prefixed_file_name= prefixed_file_name+"/";
}
prefixed_file_name= prefixed_file_name+filename;
open(prefixed_file_name.c_str());
if(!this->good())cerr<<"tbcrent: File "<<prefixed_file_name<<
" couldn't be opened"<<endl;


/*:8*/
#line 188 "tbcrent.w"

}
};


class prefixed_ofstream:public ofstream{
public:
prefixed_ofstream(string filename):ofstream(){
/*8:*/
#line 203 "tbcrent.w"

string prefixed_file_name(file_name_prefix);
if(!file_name_prefix.empty()){
if(file_name_prefix[file_name_prefix.size()-1]!='/')
prefixed_file_name= prefixed_file_name+"/";
}
prefixed_file_name= prefixed_file_name+filename;
open(prefixed_file_name.c_str());
if(!this->good())cerr<<"tbcrent: File "<<prefixed_file_name<<
" couldn't be opened"<<endl;


/*:8*/
#line 196 "tbcrent.w"

}
};

/*:7*//*10:*/
#line 232 "tbcrent.w"

int string_to_dec(string number){
istringstream ss(number);
int result= 0;

if(number.find("#")!=string::npos)return 0;

if(number.find("x")==string::npos)

ss>>result;
else{
char c;
do ss>>c;while(c!='x');
ss>>hex>>result;
}
return result;
}

/*:10*//*11:*/
#line 253 "tbcrent.w"

string dec_to_hex(int a){
ostringstream result;

result<<"0x"<<hex<<a;
return result.str();
}

/*:11*//*12:*/
#line 270 "tbcrent.w"

class entity{
int unicode;
string name,latex_macro;
bool unicode_changed,name_changed,latex_macro_changed;
public:
entity():name_changed(false),latex_macro_changed(false),
unicode_changed(false),unicode(0){}
void set_unicode(const int u);
void set_name(const string n);
void set_latex_macro(const string m);
int get_unicode()const{return unicode;}
string get_name()const{return name;}
string get_latex_macro()const{return latex_macro;}
};

/*:12*//*13:*/
#line 288 "tbcrent.w"

void entity::set_unicode(const int u){
if(u==0)return;
if(!unicode_changed){
unicode= u;
unicode_changed= true;
}else if(unicode!=u)
cerr<<"tbcrent: Entity \""<<name<<"\" with unicode "
<<unicode<<" is assigned unicode "<<u<<endl;
}

void entity::set_name(const string n){
if(n.empty())return;
if(!name_changed){
name= n;
name_changed= true;
}
}

void entity::set_latex_macro(const string m){
if(m.empty())return;
if(!latex_macro_changed&&!m.empty()){
latex_macro= m;
latex_macro_changed= true;
}else if(latex_macro!=m)
cerr<<"tbcrent: Entity \""<<name<<"\" with LaTeX macro \""
<<latex_macro<<"\" is assigned LaTeX macro \""<<m
<<"\""<<endl;
}

/*:13*//*15:*/
#line 332 "tbcrent.w"

typedef map<int,entity> entities_by_unicode;
typedef map<string,entity> entities_by_names;

/*:15*//*17:*/
#line 362 "tbcrent.w"

void read_entity_file(ifstream&in,entities_by_names&name_list){
string line;
string::size_type position;

while(getline(in,line)){
position= line.find("<!ENTITY ");
if(position!=string::npos){
string entity_name,subst;
position+= 9;
while(isspace(line[position]))position++;
if(line[position]!='%'){
while(!isspace(line[position]))entity_name+= line[position++];
while(line[position]!='\"')position++;
position++;
while(line[position]!='\"')subst+= line[position++];
if(subst[0]=='&'){
const int unicode= string_to_dec(subst.substr(2,subst.size()-3));
name_list[entity_name].set_name(entity_name);
name_list[entity_name].set_unicode(unicode);
}else if(entity_name.substr(0,4)=="uc--"){
const int unicode= string_to_dec(entity_name.substr(4,entity_name.size()-4));
name_list[entity_name].set_name(entity_name);
name_list[entity_name].set_unicode(unicode);
name_list[entity_name].set_latex_macro(subst);
}else name_list[entity_name].set_latex_macro(subst);
}
}
}
}

/*:17*//*20:*/
#line 428 "tbcrent.w"

void write_entity_file(ostream&out,entities_by_unicode&unicode_list){
typedef entities_by_unicode::const_iterator ci;
int last_unicode= 0;

for(ci p= unicode_list.begin();p!=unicode_list.end();++p){
const int unicode= p->first;
const entity e= p->second;
const string name= e.get_name(),latex_macro= e.get_latex_macro();

if(latex_macro.empty())continue;
if(last_unicode!=0){
if(unicode-last_unicode> 1)out<<'\n';
if(unicode-last_unicode> 100)out<<'\n';
if(unicode-last_unicode> 1000)out<<'\n';
}
out<<"0x"<<hex<<unicode<<'\t'<<name;
for(int i= name.size();i<25;i++)out<<' ';
out<<'\"'<<latex_macro<<'\"'<<'\n';
last_unicode= unicode;
}
}

/*:20*//*22:*/
#line 458 "tbcrent.w"

/*2:*/
#line 99 "tbcrent.w"

int main(){
entities_by_unicode unicode_list;
entities_by_names name_list;

/*3:*/
#line 118 "tbcrent.w"

char*filenames[number_of_files]= {"mathml/mmlalias.ent",
"iso8879/isoamsr.ent","iso9573-13/isoamsr.ent",
"iso8879/isogrk1.ent",
"iso8879/isogrk2.ent",
"iso8879/isogrk4.ent","iso9573-13/isogrk4.ent",
"iso8879/isogrk3.ent","iso9573-13/isogrk3.ent",
"iso8879/isodia.ent",
"html/lat1.ent","html/special.ent","html/symbol.ent",
"mathml/mmlextra.ent",
"iso8879/isoamsa.ent","iso9573-13/isoamsa.ent",
"iso8879/isoamsb.ent","iso9573-13/isoamsb.ent",
"iso8879/isoamsc.ent","iso9573-13/isoamsc.ent",
"iso8879/isoamsn.ent","iso9573-13/isoamsn.ent",
"iso8879/isoamso.ent","iso9573-13/isoamso.ent",
"iso8879/isobox.ent",
"iso8879/isocyr1.ent","iso8879/isocyr2.ent",
"iso8879/isolat1.ent","iso8879/isolat2.ent",
"iso9573-13/isomfrk.ent",
"iso9573-13/isomopf.ent","iso9573-13/isomscr.ent",
"iso8879/isonum.ent","iso8879/isopub.ent",
"iso8879/isotech.ent","iso9573-13/isotech.ent",
"tblatex.ent"
};

/*:3*/
#line 104 "tbcrent.w"

/*4:*/
#line 145 "tbcrent.w"

for(int i= 0;i<number_of_files;i++){
string filename(filenames[i]);
prefixed_ifstream entity_file(filename);
read_entity_file(entity_file,name_list);
}


/*:4*/
#line 105 "tbcrent.w"

/*19:*/
#line 403 "tbcrent.w"

typedef entities_by_names::const_iterator ci;
for(ci p= name_list.begin();p!=name_list.end();++p){
const int unicode= p->second.get_unicode();
if(unicode!=0){
unicode_list[unicode].set_unicode(unicode);
unicode_list[unicode].set_name(p->first);
unicode_list[unicode].set_latex_macro(p->second.get_latex_macro());
}
}

/*:19*/
#line 106 "tbcrent.w"


prefixed_ofstream tbents_txt(entities_file_name);
write_entity_file(tbents_txt,unicode_list);
return 0;
}

/*:2*/
#line 459 "tbcrent.w"


/*:22*/
